## pynx-2023.1.1.tar.bz2

=== requirements.txt ===
# This is a minimal setp of required packages to use most features
# in PyNX. It includes OpenCL by default.
#
# See requirements_cuda.txt and requirements_gui.txt for extras
# to use CUDA some graphical user interfaces elements.
#
# Installing CUDA is *highly* recommended if you have an nvidia card as
# performance will be better than with OpenCL.
#
# You can install PyNX from it directory using either:
# * pip install .
# * pip install .[cuda]
# * pip install .[cuda,gui]
# * pip install .[cuda,gui,mpi]
#
# Or from an archive (or using git+https):
# * pip install http://ftp.esrf.fr/pub/scisoft/PyNX/pynx-devel-nightly.tar.bz2[cuda,gui, mpi]
#
numpy>=1.12
scipy>=1.6.0
matplotlib
setuptools
cython
scikit-image>=0.17
h5py>=2.9
hdf5plugin
fabio
silx
packaging
psutil
scikit-learn
mako
pyopencl
# This is now the base GPU FFT library (CUDA or OpenCL).
# scikit-cuda and gpyfft can still be used instead
pyvkfft>=2022.1
# numba can be used for some experimental features in CDI
# numba
# The following are only required for holotomo
nabu
tomoscan
tifffile

=== debian/changelog ===
pynx (2021.1~b0-1) UNRELEASED; urgency=medium

  * Initial release (Closes: #nnnn)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 21 Sep 2017 13:13:04 +0200

=== debian/control ===
Source: pynx
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>
Build-Depends: cython3,
               debhelper-compat (= 12),
               dh-python,
               python3-all-dev,
               python3-fabio <!nodoc>,
               python3-gpyfft <!nodoc>,
               python3-h5py <!nodoc>,
               python3-matplotlib <!nodoc>,
               python3-nbsphinx <!nodoc>,
               python3-networkx <!nodoc>,
               python3-numba,
               python3-numpy,
               python3-pyopencl <!nodoc>,
               python3-scipy,
               python3-setuptools,
               python3-skimage <!nodoc>,
               python3-sphinx <!nodoc>,
               python3-tk <!nodoc>,
               sphinx-common
Standards-Version: 4.1.0
Homepage: http://ftp.esrf.fr/pub/scisoft/PyNX/doc/
X-Python3-Version: >= 3.2

Package: pynx
Architecture: all
Depends: python3-pynx (>= ${source:Version}),
         ${misc:Depends},
         ${python3:Depends}
Description: Python tools for Nano-structures Crystallography (Scripts)
 PyNX stands for *Python tools for Nano-structures Crystallography*.
 It is a python library with the following main modules:
 .
 1) pynx.scattering: *X-ray scattering computing using graphical
 processing units*, allowing up to 2.5x10^11 reflections/atoms/seconds
 (single nVidia Titan X). The sub-module``pynx.scattering.gid`` can be
 used for *Grazing Incidence Diffraction* calculations, using the
 Distorted Wave Born Approximation
 .
 2) pynx.ptycho : simulation and analysis of experiments using the
 *ptychography* technique, using either CPU (deprecated) or GPU using
 OpenCL.  Examples are available in the pynx/Examples
 directory. Scripts for analysis of raw data from beamlines are also
 available, as well as using or producing ptychography data sets in
 CXI (Coherent X-ray Imaging) format.
 .
 3) pynx.wavefront: *X-ray wavefront propagation* in the near, far
 field, or continuous (examples available at the end of
 ``wavefront.py``).  Also provided are sub-modules for Fresnel
 propagation and simulation of the illumination from a Fresnel Zone
 Plate, both using OpenCL for high performance computing.
 .
 4) pynx.cdi: *Coherent Diffraction Imaging* reconstruction algorithms
 using GPU.
 .
 In addition, it includes :doc:`scripts <scripts/index>` for
 command-line processing of ptychography data from generic CXI data
 (pynx-ptycho-cxi) or specific to beamlines (pynx-ptycho-id01,
 pynx-ptycho-id13,...).

Package: python3-pynx
Architecture: any
Section: python
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Suggests: python-pynx-doc
Description: Python tools for Nano-structures Crystallography (Python 3)
 PyNX stands for *Python tools for Nano-structures Crystallography*.
 It is a python library with the following main modules:
 .
 1) pynx.scattering: *X-ray scattering computing using graphical
 processing units*, allowing up to 2.5x10^11 reflections/atoms/seconds
 (single nVidia Titan X). The sub-module``pynx.scattering.gid`` can be
 used for *Grazing Incidence Diffraction* calculations, using the
 Distorted Wave Born Approximation
 .
 2) pynx.ptycho : simulation and analysis of experiments using the
 *ptychography* technique, using either CPU (deprecated) or GPU using
 OpenCL.  Examples are available in the pynx/Examples
 directory. Scripts for analysis of raw data from beamlines are also
 available, as well as using or producing ptychography data sets in
 CXI (Coherent X-ray Imaging) format.
 .
 3) pynx.wavefront: *X-ray wavefront propagation* in the near, far
 field, or continuous (examples available at the end of
 ``wavefront.py``).  Also provided are sub-modules for Fresnel
 propagation and simulation of the illumination from a Fresnel Zone
 Plate, both using OpenCL for high performance computing.
 .
 4) pynx.cdi: *Coherent Diffraction Imaging* reconstruction algorithms
 using GPU.
 .
 In addition, it includes :doc:`scripts <scripts/index>` for
 command-line processing of ptychography data from generic CXI data
 (pynx-ptycho-cxi) or specific to beamlines (pynx-ptycho-id01,
 pynx-ptycho-id13,...).
 .
 This package installs the library for Python 3.

Package: python-pynx-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: Python tools for Nano-structures Crystallography (common documentation)
 PyNX stands for *Python tools for Nano-structures Crystallography*.
 It is a python library with the following main modules:
 .
 1) pynx.scattering: *X-ray scattering computing using graphical
 processing units*, allowing up to 2.5x10^11 reflections/atoms/seconds
 (single nVidia Titan X). The sub-module``pynx.scattering.gid`` can be
 used for *Grazing Incidence Diffraction* calculations, using the
 Distorted Wave Born Approximation
 .
 2) pynx.ptycho : simulation and analysis of experiments using the
 *ptychography* technique, using either CPU (deprecated) or GPU using
 OpenCL.  Examples are available in the pynx/Examples
 directory. Scripts for analysis of raw data from beamlines are also
 available, as well as using or producing ptychography data sets in
 CXI (Coherent X-ray Imaging) format.
 .
 3) pynx.wavefront: *X-ray wavefront propagation* in the near, far
 field, or continuous (examples available at the end of
 ``wavefront.py``).  Also provided are sub-modules for Fresnel
 propagation and simulation of the illumination from a Fresnel Zone
 Plate, both using OpenCL for high performance computing.
 .
 4) pynx.cdi: *Coherent Diffraction Imaging* reconstruction algorithms
 using GPU.
 .
 In addition, it includes :doc:`scripts <scripts/index>` for
 command-line processing of ptychography data from generic CXI data
 (pynx-ptycho-cxi) or specific to beamlines (pynx-ptycho-id01,
 pynx-ptycho-id13,...).
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# How to recursively find all files with the same name in a given folder
rwildcard=$(wildcard $1$2) $(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2))
ALL_PYX := $(call rwildcard,pynx/,*.pyx)
#NOTA: No space before *

export PYBUILD_AFTER_INSTALL=rm -rf {destdir}/usr/bin/ {destdir}/usr/pynx/
export PYBUILD_DISABLE=test
export PYBUILD_NAME=pynx

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild


override_dh_clean:
	dh_clean
	rm -f $(patsubst %.pyx,%.c,${ALL_PYX})

override_dh_install:
	dh_numpy3

        # install scripts
	python3 setup.py install_scripts -d debian/pynx/usr/bin

	dh_install

override_dh_auto_test: export http_proxy=127.0.0.1:9
override_dh_auto_test: export https_proxy=127.0.0.1:9
override_dh_auto_test:
	dh_auto_test -- -s custom --test-args="PYTHONPATH={build_dir} {interpreter} pynx/scripts/pynx-test.py"

override_dh_sphinxdoc:
# do not build until sphinx_link is available in Debian
# ifeq (,$(findstring nodoc, $(DEB_BUILD_OPTIONS)))
# 	PYBUILD_SYSTEM=custom \
# 	PYBUILD_BUILD_ARGS="cd doc && PYTHONPATH={build_dir} http_proxy='127.0.0.1:9' {interpreter} -m sphinx -N -bhtml . build/html" dh_auto_build  # HTML generator
# 	dh_installdocs "doc/build/html" -p python-pynx-doc
# 	dh_sphinxdoc -O--buildsystem=pybuild
# endif
